<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;v9jmyrpcwymx5d6inidy85x2ljzgm935-vendored-sources&#x2F;ryu-1.0.9&#x2F;src&#x2F;f2s.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>f2s.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../ryu/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
</pre><pre class="rust"><code><span class="comment">// Translated from C to Rust. The original C code can be found at</span>
<span class="comment">// https://github.com/ulfjack/ryu and carries the following license:</span>
<span class="comment">//</span>
<span class="comment">// Copyright 2018 Ulf Adams</span>
<span class="comment">//</span>
<span class="comment">// The contents of this file may be used under the terms of the Apache License,</span>
<span class="comment">// Version 2.0.</span>
<span class="comment">//</span>
<span class="comment">//    (See accompanying file LICENSE-Apache or copy at</span>
<span class="comment">//     http://www.apache.org/licenses/LICENSE-2.0)</span>
<span class="comment">//</span>
<span class="comment">// Alternatively, the contents of this file may be used under the terms of</span>
<span class="comment">// the Boost Software License, Version 1.0.</span>
<span class="comment">//    (See accompanying file LICENSE-Boost or copy at</span>
<span class="comment">//     https://www.boost.org/LICENSE_1_0.txt)</span>
<span class="comment">//</span>
<span class="comment">// Unless required by applicable law or agreed to in writing, this software</span>
<span class="comment">// is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY</span>
<span class="comment">// KIND, either express or implied.</span>

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::common</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::f2s_intrinsics</span>::<span class="kw-2">*</span>;

<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">FLOAT_MANTISSA_BITS</span>: <span class="ident">u32</span> <span class="op">=</span> <span class="number">23</span>;
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">FLOAT_EXPONENT_BITS</span>: <span class="ident">u32</span> <span class="op">=</span> <span class="number">8</span>;
<span class="kw">const</span> <span class="ident">FLOAT_BIAS</span>: <span class="ident">i32</span> <span class="op">=</span> <span class="number">127</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::f2s_intrinsics</span>::{<span class="ident">FLOAT_POW5_BITCOUNT</span>, <span class="ident">FLOAT_POW5_INV_BITCOUNT</span>};

<span class="comment">// A floating decimal representing m * 10^e.</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">FloatingDecimal32</span> {
    <span class="kw">pub</span> <span class="ident">mantissa</span>: <span class="ident">u32</span>,
    <span class="comment">// Decimal exponent&#39;s range is -45 to 38</span>
    <span class="comment">// inclusive, and can fit in i16 if needed.</span>
    <span class="kw">pub</span> <span class="ident">exponent</span>: <span class="ident">i32</span>,
}

<span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;no-panic&quot;</span>, <span class="ident">inline</span>)]</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">f2d</span>(<span class="ident">ieee_mantissa</span>: <span class="ident">u32</span>, <span class="ident">ieee_exponent</span>: <span class="ident">u32</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">FloatingDecimal32</span> {
    <span class="kw">let</span> (<span class="ident">e2</span>, <span class="ident">m2</span>) <span class="op">=</span> <span class="kw">if</span> <span class="ident">ieee_exponent</span> <span class="op">=</span><span class="op">=</span> <span class="number">0</span> {
        (
            <span class="comment">// We subtract 2 so that the bounds computation has 2 additional bits.</span>
            <span class="number">1</span> <span class="op">-</span> <span class="ident">FLOAT_BIAS</span> <span class="op">-</span> <span class="ident">FLOAT_MANTISSA_BITS</span> <span class="kw">as</span> <span class="ident">i32</span> <span class="op">-</span> <span class="number">2</span>,
            <span class="ident">ieee_mantissa</span>,
        )
    } <span class="kw">else</span> {
        (
            <span class="ident">ieee_exponent</span> <span class="kw">as</span> <span class="ident">i32</span> <span class="op">-</span> <span class="ident">FLOAT_BIAS</span> <span class="op">-</span> <span class="ident">FLOAT_MANTISSA_BITS</span> <span class="kw">as</span> <span class="ident">i32</span> <span class="op">-</span> <span class="number">2</span>,
            (<span class="number">1u32</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="ident">FLOAT_MANTISSA_BITS</span>) <span class="op">|</span> <span class="ident">ieee_mantissa</span>,
        )
    };
    <span class="kw">let</span> <span class="ident">even</span> <span class="op">=</span> (<span class="ident">m2</span> <span class="op">&amp;</span> <span class="number">1</span>) <span class="op">=</span><span class="op">=</span> <span class="number">0</span>;
    <span class="kw">let</span> <span class="ident">accept_bounds</span> <span class="op">=</span> <span class="ident">even</span>;

    <span class="comment">// Step 2: Determine the interval of valid decimal representations.</span>
    <span class="kw">let</span> <span class="ident">mv</span> <span class="op">=</span> <span class="number">4</span> <span class="op">*</span> <span class="ident">m2</span>;
    <span class="kw">let</span> <span class="ident">mp</span> <span class="op">=</span> <span class="number">4</span> <span class="op">*</span> <span class="ident">m2</span> <span class="op">+</span> <span class="number">2</span>;
    <span class="comment">// Implicit bool -&gt; int conversion. True is 1, false is 0.</span>
    <span class="kw">let</span> <span class="ident">mm_shift</span> <span class="op">=</span> (<span class="ident">ieee_mantissa</span> <span class="op">!</span><span class="op">=</span> <span class="number">0</span> <span class="op">|</span><span class="op">|</span> <span class="ident">ieee_exponent</span> <span class="op">&lt;</span><span class="op">=</span> <span class="number">1</span>) <span class="kw">as</span> <span class="ident">u32</span>;
    <span class="kw">let</span> <span class="ident">mm</span> <span class="op">=</span> <span class="number">4</span> <span class="op">*</span> <span class="ident">m2</span> <span class="op">-</span> <span class="number">1</span> <span class="op">-</span> <span class="ident">mm_shift</span>;

    <span class="comment">// Step 3: Convert to a decimal power base using 64-bit arithmetic.</span>
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">vr</span>: <span class="ident">u32</span>;
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">vp</span>: <span class="ident">u32</span>;
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">vm</span>: <span class="ident">u32</span>;
    <span class="kw">let</span> <span class="ident">e10</span>: <span class="ident">i32</span>;
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">vm_is_trailing_zeros</span> <span class="op">=</span> <span class="bool-val">false</span>;
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">vr_is_trailing_zeros</span> <span class="op">=</span> <span class="bool-val">false</span>;
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">last_removed_digit</span> <span class="op">=</span> <span class="number">0u8</span>;
    <span class="kw">if</span> <span class="ident">e2</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">0</span> {
        <span class="kw">let</span> <span class="ident">q</span> <span class="op">=</span> <span class="ident">log10_pow2</span>(<span class="ident">e2</span>);
        <span class="ident">e10</span> <span class="op">=</span> <span class="ident">q</span> <span class="kw">as</span> <span class="ident">i32</span>;
        <span class="kw">let</span> <span class="ident">k</span> <span class="op">=</span> <span class="ident">FLOAT_POW5_INV_BITCOUNT</span> <span class="op">+</span> <span class="ident">pow5bits</span>(<span class="ident">q</span> <span class="kw">as</span> <span class="ident">i32</span>) <span class="op">-</span> <span class="number">1</span>;
        <span class="kw">let</span> <span class="ident">i</span> <span class="op">=</span> <span class="op">-</span><span class="ident">e2</span> <span class="op">+</span> <span class="ident">q</span> <span class="kw">as</span> <span class="ident">i32</span> <span class="op">+</span> <span class="ident">k</span>;
        <span class="ident">vr</span> <span class="op">=</span> <span class="ident">mul_pow5_inv_div_pow2</span>(<span class="ident">mv</span>, <span class="ident">q</span>, <span class="ident">i</span>);
        <span class="ident">vp</span> <span class="op">=</span> <span class="ident">mul_pow5_inv_div_pow2</span>(<span class="ident">mp</span>, <span class="ident">q</span>, <span class="ident">i</span>);
        <span class="ident">vm</span> <span class="op">=</span> <span class="ident">mul_pow5_inv_div_pow2</span>(<span class="ident">mm</span>, <span class="ident">q</span>, <span class="ident">i</span>);
        <span class="kw">if</span> <span class="ident">q</span> <span class="op">!</span><span class="op">=</span> <span class="number">0</span> <span class="op">&amp;&amp;</span> (<span class="ident">vp</span> <span class="op">-</span> <span class="number">1</span>) <span class="op">/</span> <span class="number">10</span> <span class="op">&lt;</span><span class="op">=</span> <span class="ident">vm</span> <span class="op">/</span> <span class="number">10</span> {
            <span class="comment">// We need to know one removed digit even if we are not going to loop below. We could use</span>
            <span class="comment">// q = X - 1 above, except that would require 33 bits for the result, and we&#39;ve found that</span>
            <span class="comment">// 32-bit arithmetic is faster even on 64-bit machines.</span>
            <span class="kw">let</span> <span class="ident">l</span> <span class="op">=</span> <span class="ident">FLOAT_POW5_INV_BITCOUNT</span> <span class="op">+</span> <span class="ident">pow5bits</span>(<span class="ident">q</span> <span class="kw">as</span> <span class="ident">i32</span> <span class="op">-</span> <span class="number">1</span>) <span class="op">-</span> <span class="number">1</span>;
            <span class="ident">last_removed_digit</span> <span class="op">=</span>
                (<span class="ident">mul_pow5_inv_div_pow2</span>(<span class="ident">mv</span>, <span class="ident">q</span> <span class="op">-</span> <span class="number">1</span>, <span class="op">-</span><span class="ident">e2</span> <span class="op">+</span> <span class="ident">q</span> <span class="kw">as</span> <span class="ident">i32</span> <span class="op">-</span> <span class="number">1</span> <span class="op">+</span> <span class="ident">l</span>) <span class="op">%</span> <span class="number">10</span>) <span class="kw">as</span> <span class="ident">u8</span>;
        }
        <span class="kw">if</span> <span class="ident">q</span> <span class="op">&lt;</span><span class="op">=</span> <span class="number">9</span> {
            <span class="comment">// The largest power of 5 that fits in 24 bits is 5^10, but q &lt;= 9 seems to be safe as well.</span>
            <span class="comment">// Only one of mp, mv, and mm can be a multiple of 5, if any.</span>
            <span class="kw">if</span> <span class="ident">mv</span> <span class="op">%</span> <span class="number">5</span> <span class="op">=</span><span class="op">=</span> <span class="number">0</span> {
                <span class="ident">vr_is_trailing_zeros</span> <span class="op">=</span> <span class="ident">multiple_of_power_of_5_32</span>(<span class="ident">mv</span>, <span class="ident">q</span>);
            } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">accept_bounds</span> {
                <span class="ident">vm_is_trailing_zeros</span> <span class="op">=</span> <span class="ident">multiple_of_power_of_5_32</span>(<span class="ident">mm</span>, <span class="ident">q</span>);
            } <span class="kw">else</span> {
                <span class="ident">vp</span> <span class="op">-</span><span class="op">=</span> <span class="ident">multiple_of_power_of_5_32</span>(<span class="ident">mp</span>, <span class="ident">q</span>) <span class="kw">as</span> <span class="ident">u32</span>;
            }
        }
    } <span class="kw">else</span> {
        <span class="kw">let</span> <span class="ident">q</span> <span class="op">=</span> <span class="ident">log10_pow5</span>(<span class="op">-</span><span class="ident">e2</span>);
        <span class="ident">e10</span> <span class="op">=</span> <span class="ident">q</span> <span class="kw">as</span> <span class="ident">i32</span> <span class="op">+</span> <span class="ident">e2</span>;
        <span class="kw">let</span> <span class="ident">i</span> <span class="op">=</span> <span class="op">-</span><span class="ident">e2</span> <span class="op">-</span> <span class="ident">q</span> <span class="kw">as</span> <span class="ident">i32</span>;
        <span class="kw">let</span> <span class="ident">k</span> <span class="op">=</span> <span class="ident">pow5bits</span>(<span class="ident">i</span>) <span class="op">-</span> <span class="ident">FLOAT_POW5_BITCOUNT</span>;
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">j</span> <span class="op">=</span> <span class="ident">q</span> <span class="kw">as</span> <span class="ident">i32</span> <span class="op">-</span> <span class="ident">k</span>;
        <span class="ident">vr</span> <span class="op">=</span> <span class="ident">mul_pow5_div_pow2</span>(<span class="ident">mv</span>, <span class="ident">i</span> <span class="kw">as</span> <span class="ident">u32</span>, <span class="ident">j</span>);
        <span class="ident">vp</span> <span class="op">=</span> <span class="ident">mul_pow5_div_pow2</span>(<span class="ident">mp</span>, <span class="ident">i</span> <span class="kw">as</span> <span class="ident">u32</span>, <span class="ident">j</span>);
        <span class="ident">vm</span> <span class="op">=</span> <span class="ident">mul_pow5_div_pow2</span>(<span class="ident">mm</span>, <span class="ident">i</span> <span class="kw">as</span> <span class="ident">u32</span>, <span class="ident">j</span>);
        <span class="kw">if</span> <span class="ident">q</span> <span class="op">!</span><span class="op">=</span> <span class="number">0</span> <span class="op">&amp;&amp;</span> (<span class="ident">vp</span> <span class="op">-</span> <span class="number">1</span>) <span class="op">/</span> <span class="number">10</span> <span class="op">&lt;</span><span class="op">=</span> <span class="ident">vm</span> <span class="op">/</span> <span class="number">10</span> {
            <span class="ident">j</span> <span class="op">=</span> <span class="ident">q</span> <span class="kw">as</span> <span class="ident">i32</span> <span class="op">-</span> <span class="number">1</span> <span class="op">-</span> (<span class="ident">pow5bits</span>(<span class="ident">i</span> <span class="op">+</span> <span class="number">1</span>) <span class="op">-</span> <span class="ident">FLOAT_POW5_BITCOUNT</span>);
            <span class="ident">last_removed_digit</span> <span class="op">=</span> (<span class="ident">mul_pow5_div_pow2</span>(<span class="ident">mv</span>, (<span class="ident">i</span> <span class="op">+</span> <span class="number">1</span>) <span class="kw">as</span> <span class="ident">u32</span>, <span class="ident">j</span>) <span class="op">%</span> <span class="number">10</span>) <span class="kw">as</span> <span class="ident">u8</span>;
        }
        <span class="kw">if</span> <span class="ident">q</span> <span class="op">&lt;</span><span class="op">=</span> <span class="number">1</span> {
            <span class="comment">// {vr,vp,vm} is trailing zeros if {mv,mp,mm} has at least q trailing 0 bits.</span>
            <span class="comment">// mv = 4 * m2, so it always has at least two trailing 0 bits.</span>
            <span class="ident">vr_is_trailing_zeros</span> <span class="op">=</span> <span class="bool-val">true</span>;
            <span class="kw">if</span> <span class="ident">accept_bounds</span> {
                <span class="comment">// mm = mv - 1 - mm_shift, so it has 1 trailing 0 bit iff mm_shift == 1.</span>
                <span class="ident">vm_is_trailing_zeros</span> <span class="op">=</span> <span class="ident">mm_shift</span> <span class="op">=</span><span class="op">=</span> <span class="number">1</span>;
            } <span class="kw">else</span> {
                <span class="comment">// mp = mv + 2, so it always has at least one trailing 0 bit.</span>
                <span class="ident">vp</span> <span class="op">-</span><span class="op">=</span> <span class="number">1</span>;
            }
        } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">q</span> <span class="op">&lt;</span> <span class="number">31</span> {
            <span class="comment">// TODO(ulfjack): Use a tighter bound here.</span>
            <span class="ident">vr_is_trailing_zeros</span> <span class="op">=</span> <span class="ident">multiple_of_power_of_2_32</span>(<span class="ident">mv</span>, <span class="ident">q</span> <span class="op">-</span> <span class="number">1</span>);
        }
    }

    <span class="comment">// Step 4: Find the shortest decimal representation in the interval of valid representations.</span>
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">removed</span> <span class="op">=</span> <span class="number">0i32</span>;
    <span class="kw">let</span> <span class="ident">output</span> <span class="op">=</span> <span class="kw">if</span> <span class="ident">vm_is_trailing_zeros</span> <span class="op">|</span><span class="op">|</span> <span class="ident">vr_is_trailing_zeros</span> {
        <span class="comment">// General case, which happens rarely (~4.0%).</span>
        <span class="kw">while</span> <span class="ident">vp</span> <span class="op">/</span> <span class="number">10</span> <span class="op">&gt;</span> <span class="ident">vm</span> <span class="op">/</span> <span class="number">10</span> {
            <span class="ident">vm_is_trailing_zeros</span> <span class="op">&amp;=</span> <span class="ident">vm</span> <span class="op">-</span> (<span class="ident">vm</span> <span class="op">/</span> <span class="number">10</span>) <span class="op">*</span> <span class="number">10</span> <span class="op">=</span><span class="op">=</span> <span class="number">0</span>;
            <span class="ident">vr_is_trailing_zeros</span> <span class="op">&amp;=</span> <span class="ident">last_removed_digit</span> <span class="op">=</span><span class="op">=</span> <span class="number">0</span>;
            <span class="ident">last_removed_digit</span> <span class="op">=</span> (<span class="ident">vr</span> <span class="op">%</span> <span class="number">10</span>) <span class="kw">as</span> <span class="ident">u8</span>;
            <span class="ident">vr</span> <span class="op">/</span><span class="op">=</span> <span class="number">10</span>;
            <span class="ident">vp</span> <span class="op">/</span><span class="op">=</span> <span class="number">10</span>;
            <span class="ident">vm</span> <span class="op">/</span><span class="op">=</span> <span class="number">10</span>;
            <span class="ident">removed</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
        }
        <span class="kw">if</span> <span class="ident">vm_is_trailing_zeros</span> {
            <span class="kw">while</span> <span class="ident">vm</span> <span class="op">%</span> <span class="number">10</span> <span class="op">=</span><span class="op">=</span> <span class="number">0</span> {
                <span class="ident">vr_is_trailing_zeros</span> <span class="op">&amp;=</span> <span class="ident">last_removed_digit</span> <span class="op">=</span><span class="op">=</span> <span class="number">0</span>;
                <span class="ident">last_removed_digit</span> <span class="op">=</span> (<span class="ident">vr</span> <span class="op">%</span> <span class="number">10</span>) <span class="kw">as</span> <span class="ident">u8</span>;
                <span class="ident">vr</span> <span class="op">/</span><span class="op">=</span> <span class="number">10</span>;
                <span class="ident">vp</span> <span class="op">/</span><span class="op">=</span> <span class="number">10</span>;
                <span class="ident">vm</span> <span class="op">/</span><span class="op">=</span> <span class="number">10</span>;
                <span class="ident">removed</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
            }
        }
        <span class="kw">if</span> <span class="ident">vr_is_trailing_zeros</span> <span class="op">&amp;&amp;</span> <span class="ident">last_removed_digit</span> <span class="op">=</span><span class="op">=</span> <span class="number">5</span> <span class="op">&amp;&amp;</span> <span class="ident">vr</span> <span class="op">%</span> <span class="number">2</span> <span class="op">=</span><span class="op">=</span> <span class="number">0</span> {
            <span class="comment">// Round even if the exact number is .....50..0.</span>
            <span class="ident">last_removed_digit</span> <span class="op">=</span> <span class="number">4</span>;
        }
        <span class="comment">// We need to take vr + 1 if vr is outside bounds or we need to round up.</span>
        <span class="ident">vr</span> <span class="op">+</span> ((<span class="ident">vr</span> <span class="op">=</span><span class="op">=</span> <span class="ident">vm</span> <span class="op">&amp;&amp;</span> (<span class="op">!</span><span class="ident">accept_bounds</span> <span class="op">|</span><span class="op">|</span> <span class="op">!</span><span class="ident">vm_is_trailing_zeros</span>)) <span class="op">|</span><span class="op">|</span> <span class="ident">last_removed_digit</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">5</span>)
            <span class="kw">as</span> <span class="ident">u32</span>
    } <span class="kw">else</span> {
        <span class="comment">// Specialized for the common case (~96.0%). Percentages below are relative to this.</span>
        <span class="comment">// Loop iterations below (approximately):</span>
        <span class="comment">// 0: 13.6%, 1: 70.7%, 2: 14.1%, 3: 1.39%, 4: 0.14%, 5+: 0.01%</span>
        <span class="kw">while</span> <span class="ident">vp</span> <span class="op">/</span> <span class="number">10</span> <span class="op">&gt;</span> <span class="ident">vm</span> <span class="op">/</span> <span class="number">10</span> {
            <span class="ident">last_removed_digit</span> <span class="op">=</span> (<span class="ident">vr</span> <span class="op">%</span> <span class="number">10</span>) <span class="kw">as</span> <span class="ident">u8</span>;
            <span class="ident">vr</span> <span class="op">/</span><span class="op">=</span> <span class="number">10</span>;
            <span class="ident">vp</span> <span class="op">/</span><span class="op">=</span> <span class="number">10</span>;
            <span class="ident">vm</span> <span class="op">/</span><span class="op">=</span> <span class="number">10</span>;
            <span class="ident">removed</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
        }
        <span class="comment">// We need to take vr + 1 if vr is outside bounds or we need to round up.</span>
        <span class="ident">vr</span> <span class="op">+</span> (<span class="ident">vr</span> <span class="op">=</span><span class="op">=</span> <span class="ident">vm</span> <span class="op">|</span><span class="op">|</span> <span class="ident">last_removed_digit</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">5</span>) <span class="kw">as</span> <span class="ident">u32</span>
    };
    <span class="kw">let</span> <span class="ident">exp</span> <span class="op">=</span> <span class="ident">e10</span> <span class="op">+</span> <span class="ident">removed</span>;

    <span class="ident">FloatingDecimal32</span> {
        <span class="ident">exponent</span>: <span class="ident">exp</span>,
        <span class="ident">mantissa</span>: <span class="ident">output</span>,
    }
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="ryu" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>